From 8e2e0efe737eab9791e06882082831929c94d21a Mon Sep 17 00:00:00 2001
From: Sebastian Pop <spop@amazon.com>
Date: Tue, 22 Jun 2021 23:22:17 +0000
Subject: [PATCH] arm64 port x265_filterPixelToShort_*_neon

convert_p2s[  4x4]		1.21x 	 4.98     	 6.03
convert_p2s[  8x8]		2.20x 	 6.20     	 13.65
convert_p2s[16x16]		1.54x 	 25.24    	 38.94
convert_p2s[32x32]		1.49x 	 101.99   	 151.63
convert_p2s[64x64]		1.48x 	 420.31   	 622.36
convert_p2s[  8x4]		2.18x 	 3.05     	 6.64
convert_p2s[  4x8]		1.91x 	 6.01     	 11.49
convert_p2s[ 16x8]		1.47x 	 12.19    	 17.92
convert_p2s[ 8x16]		1.95x 	 13.30    	 25.94
convert_p2s[32x16]		1.49x 	 50.63    	 75.58
convert_p2s[16x32]		1.56x 	 49.92    	 77.66
convert_p2s[64x32]		1.49x 	 209.43   	 312.13
convert_p2s[32x64]		1.48x 	 205.16   	 304.53
convert_p2s[16x12]		1.65x 	 17.62    	 29.08
convert_p2s[12x16]		6.22x 	 24.07    	 149.61
convert_p2s[ 16x4]		1.60x 	 5.37     	 8.59
convert_p2s[ 4x16]		1.75x 	 13.58    	 23.73
convert_p2s[32x24]		1.48x 	 76.47    	 113.22
convert_p2s[24x32]		2.69x 	 78.12    	 210.52
convert_p2s[ 32x8]		1.48x 	 25.00    	 37.06
convert_p2s[ 8x32]		1.63x 	 29.10    	 47.46
convert_p2s[64x48]		1.48x 	 314.74   	 466.77
convert_p2s[64x16]		1.48x 	 104.13   	 154.48
convert_p2s[16x64]		1.58x 	 98.66    	 155.67
---
 source/common/aarch64/asm-primitives.cpp |  25 ++++
 source/common/aarch64/ipfilter8.S        | 177 +++++++++++++++++++++++
 source/common/aarch64/ipfilter8.h        |  25 ++++
 3 files changed, 227 insertions(+)

diff --git a/source/common/aarch64/asm-primitives.cpp b/source/common/aarch64/asm-primitives.cpp
index 6fe8c96..e5a1f03 100644
--- a/source/common/aarch64/asm-primitives.cpp
+++ b/source/common/aarch64/asm-primitives.cpp
@@ -214,6 +214,31 @@ void setupAssemblyPrimitives(EncoderPrimitives &p, int cpuMask)
         p.cu[BLOCK_4x4].psy_cost_pp = PFX(psyCost_4x4_neon);
 #endif // !HIGH_BIT_DEPTH
 
+        // filterPixelToShort
+        p.pu[LUMA_4x4].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_4x4_neon);
+        p.pu[LUMA_4x8].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_4x8_neon);
+        p.pu[LUMA_4x16].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_4x16_neon);
+        p.pu[LUMA_8x4].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_8x4_neon);
+        p.pu[LUMA_8x8].convert_p2s[NONALIGNED]   = PFX(filterPixelToShort_8x8_neon);
+        p.pu[LUMA_8x16].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_8x16_neon);
+        p.pu[LUMA_8x32].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_8x32_neon);
+        p.pu[LUMA_12x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_12x16_neon);
+        p.pu[LUMA_16x4].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_16x4_neon);
+        p.pu[LUMA_16x8].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_16x8_neon);
+        p.pu[LUMA_16x12].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x12_neon);
+        p.pu[LUMA_16x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x16_neon);
+        p.pu[LUMA_16x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x32_neon);
+        p.pu[LUMA_16x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_16x64_neon);
+        p.pu[LUMA_24x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_24x32_neon);
+        p.pu[LUMA_32x8].convert_p2s[NONALIGNED]  = PFX(filterPixelToShort_32x8_neon);
+        p.pu[LUMA_32x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x16_neon);
+        p.pu[LUMA_32x24].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x24_neon);
+        p.pu[LUMA_32x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x32_neon);
+        p.pu[LUMA_32x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_32x64_neon);
+        p.pu[LUMA_64x16].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x16_neon);
+        p.pu[LUMA_64x32].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x32_neon);
+        p.pu[LUMA_64x48].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x48_neon);
+        p.pu[LUMA_64x64].convert_p2s[NONALIGNED] = PFX(filterPixelToShort_64x64_neon);
     }
 }
 } // namespace X265_NS
diff --git a/source/common/aarch64/ipfilter8.S b/source/common/aarch64/ipfilter8.S
index 908c7db..63f416a 100644
--- a/source/common/aarch64/ipfilter8.S
+++ b/source/common/aarch64/ipfilter8.S
@@ -29,7 +29,184 @@
 
 .text
 
+// filterPixelToShort(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride)
+function x265_filterPixelToShort_4x4_neon
+    add             x3, x3, x3
+    movi            v2.8h, #0xe0, lsl #8
+    ld1             {v0.s}[0], [x0], x1
+    ld1             {v0.s}[1], [x0], x1
+    ld1             {v1.s}[2], [x0], x1
+    ld1             {v1.s}[3], [x0], x1
+    ushll           v3.8h, v0.8b, #6
+    ushll2          v4.8h, v1.16b, #6
+    add             v3.8h, v3.8h, v2.8h
+    add             v4.8h, v4.8h, v2.8h
+    st1             {v3.d}[0], [x2], x3
+    st1             {v3.d}[1], [x2], x3
+    st1             {v4.d}[0], [x2], x3
+    st1             {v4.d}[1], [x2], x3
+    ret
+endfunc
+
+.macro x265_filterPixelToShort_4xN h r
+function x265_filterPixelToShort_4x\h\()_neon
+    add             x3, x3, x3
+    movi            v4.8h, #0xe0, lsl #8
+.rept \r
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x0], x1
+    ushll           v0.8h, v0.8b, #6
+    ushll           v1.8h, v1.8b, #6
+    add             v2.8h, v0.8h, v4.8h
+    add             v3.8h, v1.8h, v4.8h
+    st1             {v2.4h}, [x2], x3
+    st1             {v3.4h}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+x265_filterPixelToShort_4xN 8 4
+x265_filterPixelToShort_4xN 16 8
+
+.macro x265_filterPixelToShort_8xN h r
+function x265_filterPixelToShort_8x\h\()_neon
+    add             x3, x3, x3
+    movi            v4.8h, #0xe0, lsl #8
+.rept \r
+    ld1             {v0.8b}, [x0], x1
+    ld1             {v1.8b}, [x0], x1
+    ushll           v0.8h, v0.8b, #6
+    ushll           v1.8h, v1.8b, #6
+    add             v2.8h, v0.8h, v4.8h
+    add             v3.8h, v1.8h, v4.8h
+    st1             {v2.8h}, [x2], x3
+    st1             {v3.8h}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+x265_filterPixelToShort_8xN 4 2
+x265_filterPixelToShort_8xN 8 4
+x265_filterPixelToShort_8xN 16 8
+x265_filterPixelToShort_8xN 32 16
+
+function x265_filterPixelToShort_12x16_neon
+    add             x3, x3, x3
+    sub             x3, x3, #16
+    movi            v5.8h, #0xe0, lsl #8
+.rept 16
+    ld1             {v0.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    add             v2.8h, v2.8h, v5.8h
+    add             v3.8h, v3.8h, v5.8h
+    st1             {v2.16b}, [x2], #16
+    st1             {v3.8b}, [x2], x3
+.endr
+    ret
+endfunc
+
+.macro filterPixelToShort_16xN h
+function x265_filterPixelToShort_16x\h\()_neon
+    add             x3, x3, x3
+    movi            v5.8h, #0xe0, lsl #8
+.rept \h
+    ld1             {v0.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    add             v2.8h, v2.8h, v5.8h
+    add             v3.8h, v3.8h, v5.8h
+    st1             {v2.16b-v3.16b}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+        
+filterPixelToShort_16xN 4
+filterPixelToShort_16xN 8
+filterPixelToShort_16xN 12
+filterPixelToShort_16xN 16
+filterPixelToShort_16xN 32
+filterPixelToShort_16xN 64
+
+function x265_filterPixelToShort_24x32_neon
+    add             x3, x3, x3
+    movi            v6.8h, #0xe0, lsl #8
+.rept 32
+    ld1             {v0.8b-v2.8b}, [x0], x1
+    ushll           v3.8h, v0.8b, #6
+    ushll           v4.8h, v1.8b, #6
+    ushll           v5.8h, v2.8b, #6
+    add             v3.8h, v3.8h, v6.8h
+    add             v4.8h, v4.8h, v6.8h
+    add             v5.8h, v5.8h, v6.8h
+    st1             {v3.16b-v5.16b}, [x2], x3
+.endr
+    ret
+endfunc
+
+.macro filterPixelToShort_32xN h
+function x265_filterPixelToShort_32x\h\()_neon
+    add             x3, x3, x3
+    movi            v6.8h, #0xe0, lsl #8
+.rept \h
+    ld1             {v0.16b-v1.16b}, [x0], x1
+    ushll           v2.8h, v0.8b, #6
+    ushll2          v3.8h, v0.16b, #6
+    ushll           v4.8h, v1.8b, #6
+    ushll2          v5.8h, v1.16b, #6
+    add             v2.8h, v2.8h, v6.8h
+    add             v3.8h, v3.8h, v6.8h
+    add             v4.8h, v4.8h, v6.8h
+    add             v5.8h, v5.8h, v6.8h
+    st1             {v2.16b-v5.16b}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
+
+filterPixelToShort_32xN 8
+filterPixelToShort_32xN 16
+filterPixelToShort_32xN 24
+filterPixelToShort_32xN 32
+filterPixelToShort_32xN 64
+
+.macro filterPixelToShort_64xN h
+function x265_filterPixelToShort_64x\h\()_neon
+    add             x3, x3, x3
+    sub             x3, x3, #0x40
+    movi            v4.8h, #0xe0, lsl #8
+.rept \h
+    ld1             {v0.16b-v3.16b}, [x0], x1
+    ushll           v16.8h, v0.8b, #6
+    ushll2          v17.8h, v0.16b, #6
+    ushll           v18.8h, v1.8b, #6
+    ushll2          v19.8h, v1.16b, #6
+    ushll           v20.8h, v2.8b, #6
+    ushll2          v21.8h, v2.16b, #6
+    ushll           v22.8h, v3.8b, #6
+    ushll2          v23.8h, v3.16b, #6
+    add             v16.8h, v16.8h, v4.8h
+    add             v17.8h, v17.8h, v4.8h
+    add             v18.8h, v18.8h, v4.8h
+    add             v19.8h, v19.8h, v4.8h
+    add             v20.8h, v20.8h, v4.8h
+    add             v21.8h, v21.8h, v4.8h
+    add             v22.8h, v22.8h, v4.8h
+    add             v23.8h, v23.8h, v4.8h
+    st1             {v16.16b-v19.16b}, [x2], #0x40
+    st1             {v20.16b-v23.16b}, [x2], x3
+.endr
+    ret
+endfunc
+.endm
 
+filterPixelToShort_64xN 16
+filterPixelToShort_64xN 32
+filterPixelToShort_64xN 48
+filterPixelToShort_64xN 64
 
 .macro qpel_filter_0_32b
     movi            v24.8h, #64
diff --git a/source/common/aarch64/ipfilter8.h b/source/common/aarch64/ipfilter8.h
index f9ed91e..2bc81bd 100644
--- a/source/common/aarch64/ipfilter8.h
+++ b/source/common/aarch64/ipfilter8.h
@@ -24,6 +24,31 @@
 #ifndef X265_IPFILTER8_AARCH64_H
 #define X265_IPFILTER8_AARCH64_H
 
+void x265_filterPixelToShort_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_4x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_8x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_12x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x12_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_16x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_24x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x24_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_32x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_48x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x16_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x32_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x48_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
+void x265_filterPixelToShort_64x64_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride);
 
 void x265_interp_8tap_horiz_ps_4x4_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
 void x265_interp_8tap_horiz_ps_4x8_neon(const pixel* src, intptr_t srcStride, int16_t* dst, intptr_t dstStride, int coeffIdx, int isRowExt);
-- 
2.25.1

